package com.ruoyi.doubledefense.service.impl;

import java.util.List;
import java.util.UUID;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.doubledefense.dtoGov.FourColorDiagramDTOGov;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.doubledefense.mapper.FourColorDiagramMapper;
import com.ruoyi.doubledefense.domain.FourColorDiagram;
import com.ruoyi.doubledefense.service.IFourColorDiagramService;

/**
 * 四色图Service业务层处理
 *
 * @author lyp
 * @date 2023-09-16
 */
@Service
public class FourColorDiagramServiceImpl implements IFourColorDiagramService {
    @Autowired
    private FourColorDiagramMapper fourColorDiagramMapper;

    /**
     * 四色图
     * 重预防汇聚计算节点
     *
     * @param fourColorDiagramDTOGov
     * @return
     */
    @Override
    public PageInfo<FourColorDiagramDTOGov> govSelectFourColorDiagramList(FourColorDiagramDTOGov fourColorDiagramDTOGov) {
        PageHelper.startPage(fourColorDiagramDTOGov.getPageNo(),fourColorDiagramDTOGov.getPageSize());
        List<FourColorDiagramDTOGov> fourColorDiagramDTOGovList = fourColorDiagramMapper.govSelectFourColorDiagramList(fourColorDiagramDTOGov);
        PageInfo<FourColorDiagramDTOGov> pageInfo = new PageInfo<>(fourColorDiagramDTOGovList);
        return pageInfo;
    }

    /**
     * 查询四色图
     *
     * @param id 四色图主键
     * @return 四色图
     */
    @Override
    public FourColorDiagram selectFourColorDiagramById(String id) {
        return fourColorDiagramMapper.selectFourColorDiagramById(id);
    }

    /**
     * 查询四色图列表
     *
     * @param fourColorDiagram 四色图
     * @return 四色图
     */
    @Override
    public List<FourColorDiagram> selectFourColorDiagramList(FourColorDiagram fourColorDiagram) {
        return fourColorDiagramMapper.selectFourColorDiagramList(fourColorDiagram);
    }

    /**
     * 新增四色图
     *
     * @param fourColorDiagram 四色图
     * @return 结果
     */
    @Override
    public int insertFourColorDiagram(FourColorDiagram fourColorDiagram) {
        fourColorDiagram.setId(UUID.randomUUID().toString());
        fourColorDiagram.setCreateDefault();
        return fourColorDiagramMapper.insertFourColorDiagram(fourColorDiagram);
    }

    /**
     * 修改四色图
     *
     * @param fourColorDiagram 四色图
     * @return 结果
     */
    @Override
    public int updateFourColorDiagram(FourColorDiagram fourColorDiagram) {
        if(StringUtils.isBlank(fourColorDiagram.getId())){
            throw new RuntimeException("参数错误,ID为空！");
        }
        fourColorDiagram.setUpdateDefault();
        return fourColorDiagramMapper.updateFourColorDiagram(fourColorDiagram);
    }

    /**
     * 批量删除四色图
     *
     * @param ids 需要删除的四色图主键
     * @return 结果
     */
    @Override
    public int deleteFourColorDiagramByIds(String[] ids) {
        return fourColorDiagramMapper.deleteFourColorDiagramByIds(ids);
    }

    /**
     * 删除四色图信息
     *
     * @param id 四色图主键
     * @return 结果
     */
    @Override
    public int deleteFourColorDiagramById(String id) {
        return fourColorDiagramMapper.deleteFourColorDiagramById(id);
    }
}
